
void IRdecode()
{
  volatile static unsigned long irbitwidth;  // width of data bit in uS
  volatile static byte irdata;               // temporary storage of byte value as bits are read
  volatile static byte irbitvalue;           // decimal value of bit being read (1,2,4,8,16,32,64,128)
  volatile static byte irbitcount;           // counts number of bits since start bit (only first 7 bits are used)       

  if(digitalRead(IRpin)==0)                  // check state of IR receiver output 
  {
    irbitwidth=micros();                     // bit starts when IR receiver pin goes low
    digitalWrite(13,1);
  }
  else                                       // IR receiver output high - end of bit
  {
    irbitwidth=micros()-irbitwidth;          // measure width of bit
    digitalWrite(13,0);
    if(irbitwidth>800ul)                     // bitwidth>800uS = logic "1" (logit 1 typically 1200uS)
    {
      irdata+=irbitvalue;                    // increment data by bit value
    }
    irbitvalue*=2;                           // bitvalue updated for next bit (1,2,4,8,16,32,64,128)
    irbitcount++;                            // count the bits

    if(irbitcount==7)                        // only want first 7 bits
    {
      irbitvalue=0;                          // additional bits have a value of 0
      IRC=irdata+1;                          // make data available to user
    }

    if(irbitwidth>1800ul)                    // start bit resets decoder values (startbit typically 2400uS)
    {
      irbitvalue=1;
      irbitcount=0;
      irdata=0;
    }  
  }
}
